package classes.game
{
   import classes.basic.MovieClip.TFMovieClip;
   import classes.global.Global;
   import flash.display.MovieClip;
   import flash.events.MouseEvent;
   
   public class BathStation extends StationCustomerContainer
   {
       
      
      private var uses:Number;
      
      private var dirty:Boolean;
      
      private var chanceDirty:Number;
      
      public function BathStation(param1:MovieClip, param2:String)
      {
         super(param1,5,param2);
         addListener(EVENT_ADD,onAddCustomer);
         addListener(EVENT_RETURN,onReturnCustomer);
         addListener(EVENT_REMOVE,onRemoveCustomer);
         chanceDirty = 0;
         dirty = false;
         uses = 0;
      }
      
      private function onFinishClean() : *
      {
         TFMovieClip.addLabelScript(movieClip,"finishClean",null);
         movieClip.gotoAndStop("empty");
         dirty = false;
         uses = 0;
         chanceDirty = 0;
      }
      
      override protected function onMouseUp() : *
      {
         if(Global.mouse.isEmpty())
         {
            startEvent(EVENT_REQUEST_MAINCHAR);
         }
         else if(!dirty)
         {
            super.onMouseUp();
         }
         else if(Global.mouse.getLastLocal() != null)
         {
            Global.mouse.getLastLocal().addCustomer(Global.mouse.removeCustomer());
         }
      }
      
      override protected function onMCRollOver(param1:MouseEvent) : void
      {
         if(dirty && Global.mouse.isEmpty())
         {
            super.onMCRollOver(param1);
         }
         if(!dirty && !Global.mouse.isEmpty())
         {
            super.onMCRollOver(param1);
         }
      }
      
      protected function onAddCustomer(param1:String, param2:CustomerContainer) : *
      {
         if(getTime() > 0)
         {
            start();
         }
         customer.getMovieClip().x = 50;
         customer.getMovieClip().y = -20;
         customer.getMovieClip().mcBody.gotoAndStop("bath");
      }
      
      public function clean() : *
      {
         movieClip.gotoAndPlay("cleaning");
         TFMovieClip.addLabelScript(movieClip,"finishClean",onFinishClean);
         Global.soundsFX["cleaningStation"].play();
      }
      
      private function onRemoveCustomer(param1:String, param2:CustomerContainer) : *
      {
         if(dirty)
         {
            movieClip.gotoAndStop("dirty");
         }
      }
      
      override public function onFinish() : *
      {
         var _loc1_:Number = NaN;
         super.onFinish();
         Global.soundsFX["bubblingWater"].stop();
         ++uses;
         if(uses == 3)
         {
            chanceDirty = 40;
         }
         if(uses > 3)
         {
            chanceDirty += 20;
         }
         if(chanceDirty > 0)
         {
            _loc1_ = Math.random() * 100;
            if(_loc1_ <= chanceDirty)
            {
               dirty = true;
            }
         }
      }
      
      public function isDirty() : *
      {
         return dirty;
      }
      
      override public function start() : *
      {
         super.start();
         Global.soundsFX["bubblingWater"].play();
      }
      
      private function onReturnCustomer(param1:String, param2:CustomerContainer) : *
      {
         customer.angry();
         customer.getMovieClip().x = 50;
         customer.getMovieClip().y = -20;
         customer.getMovieClip().mcBody.gotoAndStop("bath");
      }
   }
}
