package classes.game
{
   import classes.basic.Events.*;
   import classes.global.Global;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.filters.BitmapFilterQuality;
   import flash.filters.GlowFilter;
   
   public class CustomerContainer
   {
      
      public static var EVENT_RETURN:String = "EVENT_RETURN";
      
      public static var EVENT_REMOVE:String = "EVENT_REMOVE";
      
      public static var EVENT_ADD:String = "EVENT_ADD";
       
      
      protected var lastCustomer:Customer;
      
      protected var customer:Customer;
      
      protected var movieClip:MovieClip;
      
      private var action:String;
      
      private var listeners:Array;
      
      public function CustomerContainer(param1:MovieClip)
      {
         super();
         this.movieClip = param1;
         this.listeners = new Array();
         addEvent(EVENT_ADD);
         addEvent(EVENT_REMOVE);
         addEvent(EVENT_RETURN);
         param1.addEventListener(MouseEvent.ROLL_OVER,onMCRollOver,false,0,true);
         param1.addEventListener(MouseEvent.ROLL_OUT,onMCRollOut,false,0,true);
         param1.addEventListener(MouseEvent.MOUSE_DOWN,onMCDown,false,0,true);
         param1.addEventListener(MouseEvent.MOUSE_UP,onMCUp,false,0,true);
      }
      
      public function removeCustomer() : Customer
      {
         var _loc1_:Customer = null;
         _loc1_ = this.customer;
         customer.setContainer(null);
         movieClip.mcDummy.removeChild(_loc1_.getMovieClip());
         this.customer = null;
         startEvent(EVENT_REMOVE);
         return _loc1_;
      }
      
      public function isEmpty() : Boolean
      {
         return customer == null;
      }
      
      protected function onMCRollOver(param1:MouseEvent) : void
      {
         var _loc2_:GlowFilter = null;
         var _loc3_:Array = null;
         _loc2_ = new GlowFilter(16776960,1,5,5,5,BitmapFilterQuality.HIGH,false,false);
         _loc3_ = new Array();
         _loc3_.push(_loc2_);
         movieClip.filters = _loc3_;
      }
      
      protected function onMouseUp() : *
      {
         if(isEmpty() && !Global.mouse.isEmpty())
         {
            addCustomer(Global.mouse.removeCustomer());
         }
         else if(Global.mouse.getLastLocal() != null)
         {
            Global.mouse.getLastLocal().addCustomer(Global.mouse.removeCustomer());
         }
      }
      
      protected function onMouseDown() : *
      {
         if(!isEmpty() && !customer.isExit())
         {
            Global.mouse.setLastLocal(this);
            Global.mouse.addCustomer(removeCustomer());
         }
      }
      
      protected function startEvent(param1:String) : *
      {
         var _loc2_:Number = NaN;
         if(this.listeners[param1] != undefined && this.listeners[param1] != null)
         {
            _loc2_ = 0;
            while(_loc2_ < this.listeners[param1].length)
            {
               this.listeners[param1][_loc2_](param1,this);
               _loc2_++;
            }
         }
      }
      
      protected function onMCRollOut(param1:MouseEvent) : void
      {
         movieClip.filters = new Array();
      }
      
      public function addCustomer(param1:Customer) : *
      {
         if(param1 == null)
         {
            return;
         }
         this.customer = param1;
         movieClip.mcDummy.addChild(param1.getMovieClip());
         param1.setPosition(0,0);
         param1.setContainer(this);
         if(this.lastCustomer != param1)
         {
            this.lastCustomer = param1;
            startEvent(EVENT_ADD);
         }
         else
         {
            startEvent(EVENT_RETURN);
         }
      }
      
      protected function onMCUp(param1:MouseEvent) : void
      {
         onMouseUp();
      }
      
      public function addListener(param1:String, param2:Function) : *
      {
         if(this.listeners[param1] != undefined && this.listeners[param1] != null)
         {
            this.listeners[param1].push(param2);
         }
      }
      
      protected function onMCDown(param1:MouseEvent) : void
      {
         onMouseDown();
      }
      
      protected function addEvent(param1:String) : *
      {
         if(this.listeners[param1] == null || this.listeners[param1] == undefined)
         {
            this.listeners[param1] = new Array();
            ++this.listeners.length;
         }
      }
      
      public function disableMouseEvent() : *
      {
         movieClip.removeEventListener(MouseEvent.ROLL_OVER,onMCRollOver,false);
         movieClip.removeEventListener(MouseEvent.ROLL_OUT,onMCRollOut,false);
         movieClip.removeEventListener(MouseEvent.MOUSE_DOWN,onMCDown,false);
         movieClip.removeEventListener(MouseEvent.MOUSE_UP,onMCUp,false);
      }
   }
}
