package classes.game
{
   import classes.basic.MovieClip.*;
   import classes.basic.Sound.TFSoundChannel;
   import classes.global.Global;
   import flash.display.MovieClip;
   import flash.events.MouseEvent;
   
   public class StationCustomerContainer extends CustomerContainer
   {
      
      public static var EVENT_REQUEST_MAINCHAR:String = "EVENT_REQUEST_MAINCHAR";
       
      
      protected var lastTime:Number;
      
      protected var run:Boolean;
      
      private var time:Number;
      
      protected var over:Boolean;
      
      protected var soundTimer:TFSoundChannel;
      
      private var type:String;
      
      public function StationCustomerContainer(param1:MovieClip, param2:Number, param3:String)
      {
         super(param1);
         param1.visible = true;
         param1.mcClock.visible = false;
         param1.mcQueue.visible = false;
         this.time = param2 * 1000;
         this.run = false;
         this.type = param3;
         lastTime = 0;
         soundTimer = null;
         over = false;
         addEvent(EVENT_REQUEST_MAINCHAR);
      }
      
      override public function removeCustomer() : Customer
      {
         var _loc1_:Customer = null;
         _loc1_ = super.removeCustomer();
         if(over)
         {
            super.onMCRollOver(null);
         }
         else
         {
            super.onMCRollOut(null);
         }
         return _loc1_;
      }
      
      public function isCash() : Boolean
      {
         return this.customer != null && this.customer.getDesire() == Desires.CASH;
      }
      
      override protected function onMCRollOver(param1:MouseEvent) : void
      {
         over = true;
         if(!this.run)
         {
            if(!Global.mouse.isEmpty())
            {
               if(isEmpty())
               {
                  super.onMCRollOver(param1);
               }
            }
            else
            {
               super.onMCRollOver(param1);
            }
         }
      }
      
      override protected function onMouseDown() : *
      {
         if(!this.run && !isEmpty())
         {
            if(this.customer.getDesire() != Desires.CASH)
            {
               super.onMouseDown();
            }
         }
      }
      
      protected function showBusyAnimation() : *
      {
         movieClip.gotoAndPlay("busy");
      }
      
      override protected function onMouseUp() : *
      {
         if(!this.run)
         {
            if(Global.mouse.isEmpty())
            {
               startEvent(EVENT_REQUEST_MAINCHAR);
            }
            else
            {
               super.onMouseUp();
            }
         }
         else
         {
            super.onMouseUp();
         }
      }
      
      public function getTime() : *
      {
         return this.time;
      }
      
      public function isRun() : Boolean
      {
         return this.run;
      }
      
      override protected function onMCRollOut(param1:MouseEvent) : void
      {
         over = false;
         super.onMCRollOut(param1);
      }
      
      public function stopAnima() : *
      {
         if(run)
         {
            movieClip.stop();
            soundTimer.stop();
         }
      }
      
      public function onFinish() : *
      {
         this.run = false;
         this.lastTime = 0;
         movieClip.gotoAndPlay("empty");
         TFMovieClip.addLabelScript(movieClip,"empty",onEmpty);
         movieClip.mcClock.visible = false;
         if(soundTimer != null)
         {
            soundTimer.stop();
            soundTimer = null;
         }
         Global.soundsFX["endingTreatment"].play();
         if(over)
         {
            super.onMCRollOver(null);
         }
      }
      
      public function start() : *
      {
         this.run = true;
         this.lastTime = 0;
         customer.addUseStation(getType());
         showBusyAnimation();
         movieClip.mcClock.visible = true;
         movieClip.mcClock.gotoAndStop(1);
         soundTimer = Global.soundsFX["clockTicking"].play();
      }
      
      public function playAnima() : *
      {
         if(run)
         {
            movieClip.play();
            soundTimer.play();
         }
      }
      
      public function setQueue(param1:Number) : *
      {
         if(param1 > 0)
         {
            movieClip.mcQueue.visible = true;
            movieClip.mcQueue.mcText.text = String(param1);
         }
         else
         {
            movieClip.mcQueue.visible = false;
         }
      }
      
      public function getCash() : Number
      {
         return customer.getCash();
      }
      
      protected function onEmpty() : *
      {
         if(customer != null)
         {
            customer.onIdle();
         }
         movieClip.stop();
         TFMovieClip.addLabelScript(movieClip,"empty",null);
      }
      
      public function process(param1:Object) : *
      {
         var _loc2_:Number = NaN;
         if(this.time > 0 && run)
         {
            this.lastTime += param1.time;
            _loc2_ = int(this.lastTime / (this.time / 8));
            if(movieClip.mcClock.currentFrame != _loc2_)
            {
               movieClip.mcClock.gotoAndStop(_loc2_);
            }
            if(lastTime > this.time)
            {
               onFinish();
            }
         }
      }
      
      public function getType() : String
      {
         return type;
      }
   }
}
