package classes.game
{
   import classes.basic.MovieClip.*;
   import classes.global.Global;
   import flash.display.MovieClip;
   
   public class TreatmentStation extends StationCustomerContainer
   {
       
      
      internal var finish:Boolean;
      
      public function TreatmentStation(param1:MovieClip, param2:String)
      {
         super(param1,5,param2);
         finish = false;
         param1.mcBalloon.visible = false;
         addListener(EVENT_ADD,onAddCustomer);
         addListener(EVENT_RETURN,onReturnCustomer);
         addListener(EVENT_REMOVE,onRemoveCustomer);
      }
      
      override protected function onMouseDown() : *
      {
         if(finish)
         {
            super.onMouseDown();
         }
      }
      
      override protected function onMouseUp() : *
      {
         if(!isEmpty() && isRun() && !finish)
         {
            startEvent(EVENT_REQUEST_MAINCHAR);
         }
         else
         {
            super.onMouseUp();
         }
      }
      
      override public function onFinish() : *
      {
         finish = true;
         super.onFinish();
      }
      
      override public function start() : *
      {
         movieClip.mcBalloon.visible = false;
         this.run = true;
         this.lastTime = 0;
         showBusyAnimation();
         movieClip.mcClock.visible = true;
         movieClip.mcClock.gotoAndStop(1);
         soundTimer = Global.soundsFX["clockTicking"].play();
      }
      
      public function isWaiting() : Boolean
      {
         return !isEmpty() && !finish && !this.run;
      }
      
      protected function onAddCustomer(param1:String, param2:CustomerContainer) : *
      {
         finish = false;
         movieClip.mcBalloon.visible = true;
         customer.angry();
         customer.getMovieClip().x = 35;
         customer.getMovieClip().y = -26;
         customer.getMovieClip().mcBody.gotoAndStop("treatment");
         customer.addUseStation(getType());
      }
      
      override protected function onEmpty() : *
      {
         movieClip.mcBalloon.visible = false;
         super.onEmpty();
      }
      
      private function onReturnCustomer(param1:String, param2:CustomerContainer) : *
      {
         customer.angry();
         customer.getMovieClip().x = 35;
         customer.getMovieClip().y = -26;
         customer.getMovieClip().mcBody.gotoAndStop("treatment");
      }
      
      protected function onRemoveCustomer(param1:String, param2:CustomerContainer) : *
      {
         movieClip.mcBalloon.visible = false;
      }
   }
}
